# coding: utf-8

"""
    Bleumi Pay REST API

    A simple and powerful REST API to integrate ERC-20, Ethereum, xDai, Algorand payments and/or payouts into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from bleumi_pay.models.algorand_balance import AlgorandBalance  # noqa: F401,E501
from bleumi_pay.models.ethereum_balance import EthereumBalance  # noqa: F401,E501
from bleumi_pay.models.rsk_balance import RskBalance  # noqa: F401,E501


class PaymentBalances(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ethereum': 'EthereumBalance',
        'algorand': 'AlgorandBalance',
        'rsk': 'RskBalance'
    }

    attribute_map = {
        'ethereum': 'ethereum',
        'algorand': 'algorand',
        'rsk': 'rsk'
    }

    def __init__(self, ethereum=None, algorand=None, rsk=None):  # noqa: E501
        """PaymentBalances - a model defined in Swagger"""  # noqa: E501
        self._ethereum = None
        self._algorand = None
        self._rsk = None
        self.discriminator = None
        if ethereum is not None:
            self.ethereum = ethereum
        if algorand is not None:
            self.algorand = algorand
        if rsk is not None:
            self.rsk = rsk

    @property
    def ethereum(self):
        """Gets the ethereum of this PaymentBalances.  # noqa: E501


        :return: The ethereum of this PaymentBalances.  # noqa: E501
        :rtype: EthereumBalance
        """
        return self._ethereum

    @ethereum.setter
    def ethereum(self, ethereum):
        """Sets the ethereum of this PaymentBalances.


        :param ethereum: The ethereum of this PaymentBalances.  # noqa: E501
        :type: EthereumBalance
        """

        self._ethereum = ethereum

    @property
    def algorand(self):
        """Gets the algorand of this PaymentBalances.  # noqa: E501


        :return: The algorand of this PaymentBalances.  # noqa: E501
        :rtype: AlgorandBalance
        """
        return self._algorand

    @algorand.setter
    def algorand(self, algorand):
        """Sets the algorand of this PaymentBalances.


        :param algorand: The algorand of this PaymentBalances.  # noqa: E501
        :type: AlgorandBalance
        """

        self._algorand = algorand

    @property
    def rsk(self):
        """Gets the rsk of this PaymentBalances.  # noqa: E501


        :return: The rsk of this PaymentBalances.  # noqa: E501
        :rtype: RskBalance
        """
        return self._rsk

    @rsk.setter
    def rsk(self, rsk):
        """Sets the rsk of this PaymentBalances.


        :param rsk: The rsk of this PaymentBalances.  # noqa: E501
        :type: RskBalance
        """

        self._rsk = rsk

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentBalances, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentBalances):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
