# coding: utf-8

"""
    Bleumi Pay REST API

    A simple and powerful REST API to integrate ERC-20, Ethereum, xDai, Algorand payments and/or payouts into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class Payout(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'transfer_address': 'str',
        'amount': 'str',
        'authorization': 'str'
    }

    attribute_map = {
        'transfer_address': 'transferAddress',
        'amount': 'amount',
        'authorization': 'authorization'
    }

    def __init__(self, transfer_address=None, amount=None, authorization=None):  # noqa: E501
        """Payout - a model defined in Swagger"""  # noqa: E501
        self._transfer_address = None
        self._amount = None
        self._authorization = None
        self.discriminator = None
        self.transfer_address = transfer_address
        self.amount = amount
        if authorization is not None:
            self.authorization = authorization

    @property
    def transfer_address(self):
        """Gets the transfer_address of this Payout.  # noqa: E501

        Address of receiver. This address must be able to receive payments from smart contracts.  # noqa: E501

        :return: The transfer_address of this Payout.  # noqa: E501
        :rtype: str
        """
        return self._transfer_address

    @transfer_address.setter
    def transfer_address(self, transfer_address):
        """Sets the transfer_address of this Payout.

        Address of receiver. This address must be able to receive payments from smart contracts.  # noqa: E501

        :param transfer_address: The transfer_address of this Payout.  # noqa: E501
        :type: str
        """
        if transfer_address is None:
            raise ValueError("Invalid value for `transfer_address`, must not be `None`")  # noqa: E501

        self._transfer_address = transfer_address

    @property
    def amount(self):
        """Gets the amount of this Payout.  # noqa: E501

        Amount of token to transfer  # noqa: E501

        :return: The amount of this Payout.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this Payout.

        Amount of token to transfer  # noqa: E501

        :param amount: The amount of this Payout.  # noqa: E501
        :type: str
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def authorization(self):
        """Gets the authorization of this Payout.  # noqa: E501

        (Only for Algorand) Base64 serialization of an encoded LogicSig signed by the source of the payout  # noqa: E501

        :return: The authorization of this Payout.  # noqa: E501
        :rtype: str
        """
        return self._authorization

    @authorization.setter
    def authorization(self, authorization):
        """Sets the authorization of this Payout.

        (Only for Algorand) Base64 serialization of an encoded LogicSig signed by the source of the payout  # noqa: E501

        :param authorization: The authorization of this Payout.  # noqa: E501
        :type: str
        """

        self._authorization = authorization

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Payout, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Payout):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
