# coding: utf-8

"""
    Bleumi Pay REST API

    A simple and powerful REST API to integrate ERC-20, Ethereum, xDai, Algorand payments and/or payouts into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class ValidateCheckoutRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'hmac_input': 'str',
        'hmac_key_id': 'str',
        'hmac_alg': 'str',
        'hmac_value': 'str'
    }

    attribute_map = {
        'hmac_input': 'hmac_input',
        'hmac_key_id': 'hmac_keyId',
        'hmac_alg': 'hmac_alg',
        'hmac_value': 'hmac_value'
    }

    def __init__(self, hmac_input=None, hmac_key_id=None, hmac_alg=None, hmac_value=None):  # noqa: E501
        """ValidateCheckoutRequest - a model defined in Swagger"""  # noqa: E501
        self._hmac_input = None
        self._hmac_key_id = None
        self._hmac_alg = None
        self._hmac_value = None
        self.discriminator = None
        self.hmac_input = hmac_input
        self.hmac_key_id = hmac_key_id
        self.hmac_alg = hmac_alg
        self.hmac_value = hmac_value

    @property
    def hmac_input(self):
        """Gets the hmac_input of this ValidateCheckoutRequest.  # noqa: E501

        Payment Details. Passed as GET parameter in successUrl.  # noqa: E501

        :return: The hmac_input of this ValidateCheckoutRequest.  # noqa: E501
        :rtype: str
        """
        return self._hmac_input

    @hmac_input.setter
    def hmac_input(self, hmac_input):
        """Sets the hmac_input of this ValidateCheckoutRequest.

        Payment Details. Passed as GET parameter in successUrl.  # noqa: E501

        :param hmac_input: The hmac_input of this ValidateCheckoutRequest.  # noqa: E501
        :type: str
        """
        if hmac_input is None:
            raise ValueError("Invalid value for `hmac_input`, must not be `None`")  # noqa: E501

        self._hmac_input = hmac_input

    @property
    def hmac_key_id(self):
        """Gets the hmac_key_id of this ValidateCheckoutRequest.  # noqa: E501

        KeyId used to generate the HMAC. Passed as GET parameter in successUrl.  # noqa: E501

        :return: The hmac_key_id of this ValidateCheckoutRequest.  # noqa: E501
        :rtype: str
        """
        return self._hmac_key_id

    @hmac_key_id.setter
    def hmac_key_id(self, hmac_key_id):
        """Sets the hmac_key_id of this ValidateCheckoutRequest.

        KeyId used to generate the HMAC. Passed as GET parameter in successUrl.  # noqa: E501

        :param hmac_key_id: The hmac_key_id of this ValidateCheckoutRequest.  # noqa: E501
        :type: str
        """
        if hmac_key_id is None:
            raise ValueError("Invalid value for `hmac_key_id`, must not be `None`")  # noqa: E501

        self._hmac_key_id = hmac_key_id

    @property
    def hmac_alg(self):
        """Gets the hmac_alg of this ValidateCheckoutRequest.  # noqa: E501

        Algorithm used to generate the HMAC. Passed as GET parameter in successUrl.  # noqa: E501

        :return: The hmac_alg of this ValidateCheckoutRequest.  # noqa: E501
        :rtype: str
        """
        return self._hmac_alg

    @hmac_alg.setter
    def hmac_alg(self, hmac_alg):
        """Sets the hmac_alg of this ValidateCheckoutRequest.

        Algorithm used to generate the HMAC. Passed as GET parameter in successUrl.  # noqa: E501

        :param hmac_alg: The hmac_alg of this ValidateCheckoutRequest.  # noqa: E501
        :type: str
        """
        if hmac_alg is None:
            raise ValueError("Invalid value for `hmac_alg`, must not be `None`")  # noqa: E501

        self._hmac_alg = hmac_alg

    @property
    def hmac_value(self):
        """Gets the hmac_value of this ValidateCheckoutRequest.  # noqa: E501

        HMAC passed as GET parameter in successUrl.  # noqa: E501

        :return: The hmac_value of this ValidateCheckoutRequest.  # noqa: E501
        :rtype: str
        """
        return self._hmac_value

    @hmac_value.setter
    def hmac_value(self, hmac_value):
        """Sets the hmac_value of this ValidateCheckoutRequest.

        HMAC passed as GET parameter in successUrl.  # noqa: E501

        :param hmac_value: The hmac_value of this ValidateCheckoutRequest.  # noqa: E501
        :type: str
        """
        if hmac_value is None:
            raise ValueError("Invalid value for `hmac_value`, must not be `None`")  # noqa: E501

        self._hmac_value = hmac_value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ValidateCheckoutRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ValidateCheckoutRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
